## ros-melodic-rc-genicam-camera 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(rc_genicam_camera)
include(cmake/project_version.cmake)

# - Configuration for code optimization -

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RELEASE CACHE STRING "Build type: DEBUG or RELEASE" FORCE)
endif ()

# - Standard definitions -

add_definitions(-Wall)
if (CMAKE_MAJOR_VERSION VERSION_LESS "3.1.0")
  add_definitions(-std=c++11)
else ()
  set(CMAKE_CXX_STANDARD 11)
endif ()

add_definitions(-Wall)
add_definitions(-Wno-unknown-pragmas)

# checking for intel architecture and activating SSSE3 for optimization of
# rotating images

EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine COMMAND tr -d '\n' OUTPUT_VARIABLE CXX_MACHINE)
string(REGEX REPLACE "([a-zA-Z_0-9]+).*" "\\1" ARCHITECTURE ${CXX_MACHINE})

if ("${ARCHITECTURE}" STREQUAL "x86_64")
  set(USE_SSSE3 1 CACHE BOOL "Compile for SSEE3 (x86) using -mssse3")
else ()
  set(USE_SSSE3 0 CACHE BOOL "Compile for SSEE3 (x86) using -mssse3")
endif ()

if (USE_SSSE3)
  add_definitions(-mssse3)
endif ()

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  nodelet
  roscpp
  std_srvs
  sensor_msgs
  image_transport
  dynamic_reconfigure
  message_generation
)

## Generate services in the 'srv' folder
add_service_files(
    FILES
    GetGenICamParameter.srv
    SetGenICamParameter.srv
)

## Generate messages in the 'msg' folder
add_message_files(
    FILES
    ReturnValue.msg
)

## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES
  sensor_msgs
  std_msgs
)

## System dependencies are found with CMake's conventions
find_package(RC_GENICAM_API 2.0.3 REQUIRED)

#########################################
## Definitions for dynamic reconfigure ##
#########################################

#generate_dynamic_reconfigure_options(cfg/rc_genicam_camera.cfg)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES rc_stereocamera
  CATKIN_DEPENDS nodelet roscpp sensor_msgs std_msgs std_srvs
#  DEPENDS
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  ${catkin_INCLUDE_DIRS}
  ${RC_GENICAM_API_INCLUDE_DIRS}
)

add_subdirectory(src)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
        rc_genicam_camera_nodelet.xml
        README.md
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
        )
#install(DIRECTORY config DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

######################################
## Define information for packaging ##
######################################
# optionally specify dependencies of the debian package here (comma separated!)
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS OFF) # to prevent automatic addition of libs that are ORed in dependencies
set(CPACK_DEBIAN_PACKAGE_DEPENDS "rc-genicam-api (>= 2.0.3) | ros-$ENV{ROS_DISTRO}-rc-genicam-api (>= 2.0.3), ros-$ENV{ROS_DISTRO}-image-pipeline")

include(cmake/package_debian.cmake)

=== src/CMakeLists.txt ===

set(SRC
    genicam_camera_nodelet.cc
    publishers/camera_info_publisher.cc
    publishers/image_publisher.cc
    timestamp_corrector.cc
    imagelist.cc
    camerainfolist.cc)

# build and install the nodelet

add_library(rc_genicam_camera_nodelet ${SRC})

target_link_libraries(rc_genicam_camera_nodelet
  PUBLIC
    ${catkin_LIBRARIES}
  PRIVATE
    rc_genicam_api::rc_genicam_api
)

add_executable(rc_genicam_camera genicam_camera_node.cc)
target_link_libraries(rc_genicam_camera ${catkin_LIBRARIES})

install(TARGETS rc_genicam_camera rc_genicam_camera_nodelet
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

#add_dependencies(rc_genicam_camera_nodelet rc_genicam_camera_gencfg)

=== debian/changelog ===
ros-melodic-rc-genicam-camera (1.3.0-1bionic) bionic; urgency=high

  * Make frame_id configurable and improved default.

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 03 Feb 2021 23:00:00 -0000

ros-melodic-rc-genicam-camera (1.2.4-1bionic) bionic; urgency=high

  * Fixed linking problems

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 28 Jan 2021 23:00:00 -0000

ros-melodic-rc-genicam-camera (1.2.3-1bionic) bionic; urgency=high

  * Updated cmake and CI files
  * Dropped building for trusty and added building for focal on CI

 -- Heiko Hirschmueller <heiko.hirschmueller@roboception.de>  Sun, 20 Dec 2020 23:00:00 -0000

ros-melodic-rc-genicam-camera (1.2.2-1bionic) bionic; urgency=high

  * Added parameter to rotate grabbed images by 180 degrees

 -- Heiko Hirschmueller <heiko.hirschmueller@roboception.de>  Thu, 05 Sep 2019 22:00:00 -0000

ros-melodic-rc-genicam-camera (1.2.1-1bionic) bionic; urgency=high

  * Added parameter for storing all grabbed images as files
  * Minor performance optimization

 -- Heiko Hirschmueller <heiko.hirschmueller@roboception.de>  Wed, 05 Jun 2019 22:00:00 -0000

ros-melodic-rc-genicam-camera (1.2.0-1bionic) bionic; urgency=high

  * Fixed failing of loading initial GenICam parameters
  * Fixed readme.
  * Generate documentation too
  * Report errors if config or calibration file cannot be loaded

 -- Heiko Hirschmueller <heiko.hirschmueller@roboception.de>  Thu, 23 May 2019 22:00:00 -0000

ros-melodic-rc-genicam-camera (1.1.0-1bionic) bionic; urgency=high

  * Setting CameraInfo values properly from mono- or stereocamera calibration file
  * Read camera timestamp from TimestampLatchValue by default, which in GenICam standard
  * Mapping of most 8 and 16 bit pixel formats from GenICam to ROS

 -- Heiko Hirschmueller <heiko.hirschmueller@roboception.de>  Thu, 31 Jan 2019 23:00:00 -0000

ros-melodic-rc-genicam-camera (1.0.0-1bionic) bionic; urgency=high

  * Initial release

 -- Heiko Hirschmueller <heiko.hirschmueller@roboception.de>  Wed, 23 Jan 2019 23:00:00 -0000

=== debian/control ===
Source: ros-melodic-rc-genicam-camera
Section: misc
Priority: optional
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-diagnostic-updater, ros-melodic-dynamic-reconfigure, ros-melodic-image-transport, ros-melodic-message-generation, ros-melodic-nodelet, ros-melodic-rc-genicam-api (>= 2.0.3), ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-rc-genicam-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-diagnostic-updater, ros-melodic-dynamic-reconfigure, ros-melodic-image-transport, ros-melodic-message-runtime, ros-melodic-nodelet, ros-melodic-rc-genicam-api (>= 2.0.3), ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-std-srvs
Description: The rc_genicam_camera provides images from a GenICam compatible camera.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-rc-genicam-camera//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
